# mbrobot.py
# Version 1.6, May 20, 2019

import gc
from microbit import i2c, pin1, pin2, pin8, pin12, pin13, pin14
import machine
from music import pitch

_axe = 6

def w(d1, d2, s1, s2):
    try:
        i2c.write(0x10, bytearray([0, d1, s1]))
        i2c.write(0x10, bytearray([2, d2, s2]))
    except:
        print("Please switch on mbRobot!")
        while True:
            pass
    
def setSpeed(speed):
    global _v
    _v = int(speed / 100 * 255)

def forward():
    w(0, 0, _v, _v)

def backward():
    w(1, 1, _v, _v)
    
def stop():
    w(0, 0, 0, 0)
        
def right(): 
    w(0 if _v > 0 else 1, 1 if _v > 0 else 0, _v, _v)   

def left():    
    w(1 if _v > 0 else 0, 0 if _v > 0 else 1, _v, _v)

def rightArc(r):
    v = abs(_v)
    if r < _axe:
        v1 = 0
    else:            
        f = (r - _axe) / (r + _axe) * (1 - v * v / 200000)             
        v1 = int(f * v)
    if _v > 0:
        w(0, 0, v, v1)
    else:
        w(1, 1, v1, v)

def leftArc(r):
    v = abs(_v)
    if r < _axe:
        v1 = 0
    else:
        f = (r - _axe) / (r + _axe) * (1 - v * v / 200000)             
        v1 = int(f * v)
    if _v > 0:
        w(0, 0, v1, v)
    else:
        w(1, 1, v, v1)

def exit():
    stop()
    pitch(600, 100)
    gc.collect()

def getDistance():
    pin1.write_digital(1)
    pin1.write_digital(0)
    pulseTime = machine.time_pulse_us(pin2, 1, 50000)
    mm = pulseTime * 100 // 582
    return mm

pin2.set_pull(pin2.NO_PULL)
_v = 76
irLeft = pin13
irRight = pin14
ledLeft = pin8
ledRight = pin12
pitch(900, 100)


