# tcs34725.py, color sensor
# code from Pimoroni

from microbit import i2c
import struct

_addr = 0x29

class ColorSensor:
    def __init__(self):
        i2c.write(_addr, b'\x80\x03')
        i2c.write(_addr, b'\x81\x2b')

    def _scaled(self):
        crgb = self._raw()
        if crgb[0] > 0:
            return tuple(float(x) / crgb[0] for x in crgb[1:])
        return (0,0,0)

    def _raw(self):
        i2c.write(_addr, b'\xb4')
        return struct.unpack("<HHHH", i2c.read(_addr, 8))

    def getRGB(self):
        return tuple(int(x * 255) for x in self._scaled())

    def getLum(self):
        return self._raw()[0]

        
